CONSTANT MAX_DEPTH SMALLINT = 100


MAIN
	DEFINE
		c1, c2, c3, c4, c5 CHAR(2)

	OPEN WINDOW w_teste WITH FORM "teste1"
	CALL Signal()

	INPUT BY NAME c1, c2, c3, c4, c5
	CLOSE window w_teste
END MAIN

PRIVATE FUNCTION Signal()
	DEFINE 
		l_w ui.window,
		l_f ui.form,
		l_oc, l_of om.domNode

	DEFINE 
		l_goOn BOOLEAN,
		l_num SMALLINT 

	
	IF ( l_w := ui.Window.getCurrent() ) IS NOT NULL THEN
		IF ( l_f := l_w.getForm() ) IS NOT NULL  THEN
			LET l_goon = ( (l_of := l_f.getNode()) IS NOT NULL )
		END IF 
	END IF 


	IF l_goOn THEN
		LET l_num = 1
		WHILE l_num <= l_of.getChildCount()
			LET l_oc = l_of.getChildByIndex(l_num)
			CALL process_node(0, l_num, l_oc, l_of)
			LET l_num = l_num + 1
		END WHILE 
	END IF 

	CALL ui.Interface.Refresh()
		
END FUNCTION 


PRIVATE FUNCTION process_node(p_depth, p_nodeIndex, p_current_node, p_parent_node)
	DEFINE 
		p_depth,       # control the max recursive depth (just to be safe)
		p_nodeIndex    # node index in the parent node
			SMALLINT,
		p_current_node, 
		p_parent_node 
			om.domNode
	DEFINE
		l_strNode STRING,
		l_posY, l_posX, l_Width, l_num SMALLINT,
		l_edit_node, l_next_node, l_lbl_node om.domNode

	IF 
		p_depth <= MAX_DEPTH AND 
		p_current_node IS NOT NULL AND
		p_parent_node IS NOT NULL
	THEN
		IF ( p_current_node.getTagName() == "FormField" ) THEN
			IF ( p_current_node.getAttribute("required") == "1" ) THEN

				# find the position for the new label
				LET l_edit_node = p_current_node.getChildByIndex(1)
				LET l_posY = l_edit_node.getAttribute("posY")
				LET l_posX = l_edit_node.getAttribute("posX")
				LET l_Width = l_edit_node.getAttribute("gridWidth")

				# create label
            LET l_strNode = '<Label text="*" posY="', l_posY USING "<<<", '" posX="', (l_posX + l_Width + 1) USING "<<<", '" gridWidth="1"/>'

				# insert lable node
				LET l_lbl_node = p_current_node.parse(l_strNode)

				IF p_nodeIndex < p_parent_node.getChildCount() THEN
					# before next node if the current node is not the last one
					LET l_num = p_nodeIndex + 1
					LET l_next_node = p_parent_node.getChildByIndex(l_num)
					CALL p_parent_node.insertBefore(l_lbl_node, l_next_node)
				ELSE
					# after the next node if the current node is the last one
					CALL p_parent_node.appendChild(l_lbl_node)
				END IF 
			END IF 
		END IF 

		# do the same thing to every child node of the current node
		# increase recursive depth by 1
		LET l_num = 1
		WHILE l_num <= p_current_node.getChildCount()
			CALL process_node((p_depth+1), l_num, p_current_node.getChildByIndex(l_num), p_current_node)
			LET l_num = l_num + 1
		END WHILE 

	END IF 
END FUNCTION 


	
